/* Problem URL: https://codeforces.com/contest/893/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    vl fact(1e6 + 1, 1);
    nrep(i, 2, 1e6 + 1) {
        if (fact[i] != 1) {
            continue;
        }

        for (int j = i; j <= 1e6; j += i) {
            fact[j] = i;
        }
    }

    int q;
    cin >> q;

    const ll mod = 1e9 + 7;

    vl f(2e6 + 1);
    f[0] = 1;

    nrep(i, 1, 2e6 + 1) {
        f[i] = (f[i - 1] * i) % mod;
    }
    
    while (q--) {
        ll x, y;
        cin >> x >> y;

        ll tmp = x;
        map<ll, int> c;

        while (tmp > 1) {
            c[fact[tmp]]++;
            tmp /= fact[tmp];
        }

        auto fpow = [&](ll a, ll p) {
            ll ans = 1;
            ll now = a;

            rep(i, 31) {
                if ((p >> i) & 1) {
                    ans *= now;
                    ans %= mod;
                }

                now *= now;
                now %= mod;
            }

            return ans;
        };

        auto comb = [&](ll n, ll k) {
            ll ans = f[n];

            return (ans * fpow((f[k] * f[n - k]) % mod, mod - 2)) % mod;
        };

        ll ans = 1;
        for (auto i : c) {
            ans = (ans * comb(y + i.second - 1, i.second)) % mod;
        }

        ans = (ans * fpow(2, y - 1)) % mod;
        cout << ans << '\n';
    }
}
